import java.awt.*;
import java.awt.event.*;
import java.net.*;

import java.io.StringReader;
import java.io.IOException;
import java.io.InputStream;

import java.util.Properties;
import java.util.Vector;

import javax.swing.event.ChangeEvent;
import javax.swing.border.TitledBorder;
import javax.swing.border.Border;
import javax.swing.*;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import org.w3c.dom.Element;

import com.sun.xml.tree.XmlDocument;
import com.sun.xml.tree.XmlDocumentBuilder;
import com.sun.xml.tree.SimpleElementFactory;
import com.sun.xml.parser.Resolver;
import org.xml.sax.Parser;

import java.util.HashMap;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import MonitoredEntities.range;

/**
 * Frame class.
 */
public class EntRepBrowserFrame extends JFrame
{
  //private XmlDocument     doc;
  boolean bAtualizaoBloqueada = false;
  int port = 6544;
  int m_msegRefresh = 2000;
  DatagramSocket m_comm;
  TreePanel treePanel;
  JSlider jslRefresh = new JSlider();
  JLabel jlblStatus = new JLabel();
  JToggleButton btnStop = new JToggleButton("Stop",new ImageIcon("Images/stop.gif"),false);
  Vector remoteAddress = new Vector();
  AbstractAction actAddEntityType = null;
  AbstractAction actAddEntity = null;
  AbstractAction actAddParameter = null;
  AbstractAction actRemoveEntityType = null;
  AbstractAction actRemoveEntity = null;
  AbstractAction actRemoveParameter = null;
  EntityRepositoryConnector erc = new EntityRepositoryConnector();
  /**
   * The constructor. This method is called when the frame is created.
   */
  public EntRepBrowserFrame()
  {
    super("EntityRepBrowser");
    this.getContentPane().setLayout(new BorderLayout(2, 2));
    JToolBar toolBar = new JToolBar();
    toolBar.setMargin(new Insets(0, 10, 0, 10));
    toolBar.setName("Comandos Gerais");
    toolBar.setFloatable(true);
    addButtons(toolBar);
    getContentPane().add(toolBar, BorderLayout.NORTH);
    treePanel = new TreePanel(null);
    getContentPane().add(treePanel, BorderLayout.CENTER);
    AbstractAction[] entityActions = { actRemoveEntity };
    AbstractAction[] entityTypeActions = { actRemoveEntityType };
    AbstractAction[] parameterActions = { actRemoveParameter};
    AbstractAction[] entitiesActions = { actAddEntity};
    AbstractAction[] entityTypesActions = { actAddEntityType};
    AbstractAction[] parametersActions = { actAddParameter};
    treePanel.setEntityActions(entityActions);
    treePanel.setEntityTypeActions(entityTypeActions);
    treePanel.setParameterActions(parameterActions);
    treePanel.setEntitiesActions(entitiesActions);
    treePanel.setEntityTypesActions(entityTypesActions);
    treePanel.setParametersActions(parametersActions);
    // Create button.
    JButton button = new JButton("Refresh");
    button.setFont(new Font("SansSerif", Font.BOLD, 20));
    this.getContentPane().add(jlblStatus, BorderLayout.SOUTH);
    jlblStatus.setHorizontalAlignment(JLabel.CENTER);
    jlblStatus.setVerticalAlignment(JLabel.CENTER);
    /*
    Border borderTaxaAtualizaao;
    borderTaxaAtualizaao = BorderFactory.createCompoundBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Taxa de atualizao em mseg"),BorderFactory.createEmptyBorder(0,1,0,1));

    jslRefresh.setMinimum(0);
    jslRefresh.setMaximum(10000);
    jslRefresh.setMajorTickSpacing(m_msegRefresh);
    jslRefresh.setMinorTickSpacing(500);
    jslRefresh.setValue(2000);
    jslRefresh.setPaintLabels(true);
    jslRefresh.setPaintTicks(true);
    jslRefresh.setSnapToTicks(true);
    jslRefresh.setBorder(borderTaxaAtualizaao);
    jslRefresh.setMinimumSize(new Dimension(300,80));
    jslRefresh.setPreferredSize(new Dimension(300,80));
    jslRefresh.addChangeListener(new javax.swing.event.ChangeListener()
    {

    public void stateChanged(ChangeEvent e)
    {
    jslRefresh_stateChanged(e);
    }
    });
    */
    // Add window listener.

    this.addWindowListener
            (
                    new WindowAdapter()
                    {
                      public void windowClosing(WindowEvent e)
                      {
                        EntRepBrowserFrame.this.windowClosed();
                      }
                    }
            );

    updateForever();
  }

  synchronized void updateTree()
  {
    updateTree(erc.getXMLRepository());
  }


  /**
   * Called when the window was closed.
   */
  protected void windowClosed()
  {
    // Exit application.
    System.exit(0);
  }

  void updateForever()
  {
    Thread atualiza = new Thread("Update XML")
    {
      public void run()
      {
        while (true)
        {
          try
          {
            Thread.sleep(EntRepBrowserFrame.this.m_msegRefresh);
          }
          catch (java.lang.InterruptedException e)
          {
          }
          updateTree();

        }
      }
    };
    atualiza.start();
  }

  void addButtons(JToolBar toolBar)
  {
    actAddEntityType = new AbstractAction("Add Entity Type",new ImageIcon("Images/entitytype.gif"))
    { public void actionPerformed(ActionEvent e) { addEntityType(e); }  };
    actRemoveEntityType = new AbstractAction("Remove Entity Type",new ImageIcon("Images/entitytype.gif"))
    { public void actionPerformed(ActionEvent e) { removeEntityType(e); }  };
    actAddEntity = new AbstractAction("Add Entity",new ImageIcon("Images/entity.gif"))
    { public void actionPerformed(ActionEvent e) { addEntity(e); } };
    actRemoveEntity = new AbstractAction("Remove Entity",new ImageIcon("Images/entity.gif"))
    { public void actionPerformed(ActionEvent e) { removeEntity(e); } };
    actAddParameter = new AbstractAction("Add Parameter",new ImageIcon("Images/parameter.gif"))
    { public void actionPerformed(ActionEvent e) { addParameter(e); } };
    actRemoveParameter = new AbstractAction("Remove Parameter",new ImageIcon("Images/parameter.gif"))
    { public void actionPerformed(ActionEvent e) { removeParameter(e); } };

    AbstractAction[] actions = { actAddEntityType, actRemoveEntityType, actAddEntity, actRemoveEntity,actAddParameter,
     actRemoveParameter};

    Insets margem = new Insets(0,2,0,2);
    Dimension d = new Dimension(3,1);
    for (int i = 0; i < actions.length; i++)
    {
      JButton b = toolBar.add(actions[i]);
      b.setVerticalTextPosition(SwingConstants.BOTTOM);
      b.setHorizontalTextPosition(SwingConstants.CENTER);
      b.setMargin(margem);
      b.setText(actions[i].getValue("Name").toString());
      toolBar.addSeparator(d);
    }
    btnStop.addActionListener(new ActionListener() { public void actionPerformed(ActionEvent e) { stopPressed(e); } } );
    btnStop.setVerticalTextPosition(SwingConstants.BOTTOM);
    btnStop.setHorizontalTextPosition(SwingConstants.CENTER);
    btnStop.setMargin(margem);
    toolBar.add(btnStop);
  }

  public void stopPressed(ActionEvent e)
  {
    bAtualizaoBloqueada = btnStop.isSelected();
  }

  public void addEntityType(ActionEvent e)
  {
    //String host = JOptionPane.showInputDialog(this, "Digite o host");
    JPanel dataPanel = new JPanel();
    dataPanel.setLayout(new BoxLayout(dataPanel,BoxLayout.Y_AXIS));
    dataPanel.add(new JLabel("Metid")); JTextField jtfMetid = new JTextField(20); dataPanel.add(jtfMetid);
    dataPanel.add(new JLabel("Description")); JTextField jtfDescription = new JTextField(40); dataPanel.add(jtfDescription);
    if (showOptionPane(dataPanel,"EntityType details"))
    {
      erc.addEntityType(jtfMetid.getText(),jtfDescription.getText());
    }
  }

  public void removeEntityType(ActionEvent e)
  {
    EntityTypeElement ete = (EntityTypeElement)treePanel.getSelected();
    erc.removeEntityType(ete.getAttribute("metid"));
    updateTree();
  }

  public void addEntity(ActionEvent e)
  {
    EntRepElement dcmEl = (EntRepElement)treePanel.getRootSelected();
    ShowElement el = treePanel.getSelected();
    JPanel dataPanel = new JPanel();
    dataPanel.setLayout(new BoxLayout(dataPanel,BoxLayout.Y_AXIS));
    dataPanel.add(new JLabel("Meid")); JTextField jtfMeid = new JTextField(20);  dataPanel.add(jtfMeid);
    dataPanel.add(new JLabel("Description")); JTextField jtfDescription = new JTextField(40); dataPanel.add(jtfDescription);
    dataPanel.add(new JLabel("Metid")); JTextField jtfMetid = new JTextField(20); dataPanel.add(jtfMetid);
    dataPanel.add(new JLabel("Attribute")); JTextField jtfAttr = new JTextField(20); dataPanel.add(jtfAttr);
    if (showOptionPane(dataPanel,"Entity details"))
    {
      Vector vattr = new Vector();
      vattr.add(jtfAttr.getText());
      erc.addEntity(jtfMeid.getText(),jtfDescription.getText(),jtfMetid.getText(),vattr);
    }
  }

  public void removeEntity(ActionEvent e)
  {
    EntityElement ete = (EntityElement)treePanel.getSelected();
    erc.removeEntity(ete.getAttribute("meid"));
    updateTree();
  }

  boolean showOptionPane(JPanel panel, String title)
  {
    final JOptionPane optionPane = new JOptionPane(panel,JOptionPane.QUESTION_MESSAGE,JOptionPane.OK_CANCEL_OPTION);
    final JDialog dialog = new JDialog(this,title,true);
    dialog.setContentPane(optionPane);
    dialog.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
    dialog.addWindowListener(new WindowAdapter() {  public void windowClosing(WindowEvent we) {  } });
    optionPane.addPropertyChangeListener(
        new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (dialog.isVisible()
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    //If you were going to check something
                    //before closing the window, you'd do
                    //it here.
                    dialog.setVisible(false);
                }
            }
        });
    dialog.pack();
    dialog.setLocationRelativeTo(this);
    dialog.setVisible(true);

    return  ((Integer)optionPane.getValue()).intValue() == JOptionPane.OK_OPTION;
  }

  public void addParameter(ActionEvent e)
  {
    JPanel dataPanel = new JPanel();
    dataPanel.setLayout(new BoxLayout(dataPanel,BoxLayout.Y_AXIS));
    dataPanel.add(new JLabel("Pid")); JTextField jtfPid = new JTextField(20); dataPanel.add(jtfPid);
    dataPanel.add(new JLabel("Description")); JTextField jtfDescription = new JTextField(40); dataPanel.add(jtfDescription);
    dataPanel.add(new JLabel("Metid")); JTextField jtfMetid = new JTextField(20); dataPanel.add(jtfMetid);
    if (showOptionPane(dataPanel,"Parameter details"))
    {
      Vector vranges = new Vector();
      JPanel dataPanel2 = new JPanel();
      int i = 0;
      dataPanel2.setLayout(new BoxLayout(dataPanel2,BoxLayout.Y_AXIS));
      dataPanel2.add(new JLabel("Inicial Value")); JTextField jtfIniV = new JTextField(20); dataPanel2.add(jtfIniV);
      dataPanel2.add(new JLabel("End Value")); JTextField jtfEndV = new JTextField(20); dataPanel2.add(jtfEndV);
      while (showOptionPane(dataPanel2,"Range "+i))
      {
        try
        {
          range newrange = new range((new Double(jtfIniV.getText())).doubleValue(),
                                      (new Double(jtfEndV.getText())).doubleValue());
          vranges.add(newrange);
          i++;
        }
        catch (Exception ex)
        {
          JOptionPane.showMessageDialog(this,ex,"Erro na Entrada",JOptionPane.ERROR_MESSAGE);
        }
      }
      erc.addParameter(jtfPid.getText(),jtfDescription.getText(),jtfMetid.getText(),vranges);
    }
  }

  public void removeParameter(ActionEvent e)
  {
    ParameterElement ete = (ParameterElement)treePanel.getSelected();
    erc.removeParameter(ete.getAttribute("pid"));
    updateTree();
  }


  void jslRefresh_stateChanged(ChangeEvent e)
  {
    m_msegRefresh = (int)jslRefresh.getValue();
    if (m_msegRefresh == 0)
      m_msegRefresh = 500;
  }

  void config(ActionEvent e)
  {
    //System.err.println("Value antes "+jslRefresh.getValue());
    JOptionPane.showMessageDialog(this, jslRefresh  ,"Configurao", JOptionPane.QUESTION_MESSAGE);
    //System.err.println("Value depois "+jslRefresh.getValue());
  }

  static private XmlDocument createDocument (
          InputSource  input,
          ErrorHandler errorHandler
          ) throws SAXException, IOException, ParserConfigurationException
  {
    try {
      XmlDocumentBuilder    builder = new XmlDocumentBuilder ();
      builder.setIgnoringLexicalInfo (true);
      SAXParserFactory spf = SAXParserFactory.newInstance();
      spf.setValidating (false);
      SAXParser sp = spf.newSAXParser ();
      Parser parser = sp.getParser ();
      JFrame      frame;

      //
      // Configure the builder to create the right elements.
      //
      {
        Properties    props;
        SimpleElementFactory  factory;

        props = new Properties ();
        props.setProperty("*Element","ShowElement");
        props.setProperty("Entity","EntityElement");
        props.setProperty("Entities","EntitiesElement");
        props.setProperty("EntityType","EntityTypeElement");
        props.setProperty("EntityTypes","EntityTypesElement");
        props.setProperty("Parameter","ParameterElement");
        props.setProperty("Parameters","ParametersElement");
        props.setProperty("EntityRepository","EntRepElement");
        //props.setProperty("Text","InterfaceContent");
        //props.load (propsStream);
        factory = new SimpleElementFactory ();
        factory.addMapping (props, EntRepBrowserFrame.class.getClassLoader ());
        builder.setElementFactory (factory);
      }

      //
      // Configure the parser
      //
      parser.setErrorHandler (errorHandler);
      parser.setEntityResolver (new Resolver ());
      parser.setDocumentHandler (builder);
      parser.parse (input);

      // Look at how the different versions print themselvs...
      if (false) {
        builder.getDocument ().write (System.out);
        System.exit (0);
      }

      return builder.getDocument ();

    } catch (SAXParseException e) {
      // already reported
      throw e;

    } catch (SAXException e) {
      e.printStackTrace (System.out);
      throw e;

    } catch (IOException e) {
      e.printStackTrace (System.out);
      throw e;

    }
  }

  class ErrorDialog implements ErrorHandler
  {
    private void message (String level, int type, SAXParseException e)
            throws SAXParseException
    {
      String  messages [] = new String [6];

      messages [0] = level;
      messages [1] = "URI " + e.getSystemId ();
      messages [2] = "Linha " + e.getLineNumber ();
      messages [3] = "";
      messages [4] = e.getMessage ();

      // XXX may want to dump the exception, too
      bAtualizaoBloqueada = true;
      if (type != JOptionPane.INFORMATION_MESSAGE) {
        messages [5] = "Press 'Yes' to continue parsing.";
        int value = JOptionPane.showConfirmDialog (
                EntRepBrowserFrame.this,
                messages,
                "Continue Parsing?", JOptionPane.YES_NO_OPTION,
                type);
        if (value == JOptionPane.YES_OPTION)
          return;
      } else {
        messages [5] = "Erro no recupervel.";
        JOptionPane.showMessageDialog (
                EntRepBrowserFrame.this,
                messages,
                "Erro de XML fatal",
                type);
      }

      bAtualizaoBloqueada = false;
      throw e;
    }

    public void warning (SAXParseException e)
            throws SAXParseException
    {
      message ("Aviso do parser XML",
               JOptionPane.WARNING_MESSAGE, e);
    }

    public void error (SAXParseException e)
            throws SAXParseException
    {
      // normally a validity error
      message ("Erro XML no fatal", JOptionPane.ERROR_MESSAGE, e);
    }

    public void fatalError (SAXParseException e)
            throws SAXParseException
    {
      message ("Erro fatal de XML", JOptionPane.INFORMATION_MESSAGE, e);
    }
  }


  public void updateTree(String xml)
  {
    Exception err = null;
    XmlDocument doc = null;
    try
    {
      doc = createDocument(new InputSource(new StringReader(xml)), new ErrorDialog());
    }
    catch (SAXException e)
    {
      err = e;
    }
    catch (IOException e)
    {
      err = e;
    }
    catch (RuntimeException e)
    {
      err = e;
    }
    catch (ParserConfigurationException e)
    {
      err = e;
    }
    if (err != null)
    {
      //System.out.println("t:"+err.getLocalizedMessage());
      jlblStatus.setForeground(Color.red);
      jlblStatus.setText(
              "Erro no recebimento: '"
              + err.getLocalizedMessage()
              + "' em "
              + RepTimer.getTime());
      //err.printStackTrace (System.err);
    }
    final XmlDocument doc2 = doc;
    Runnable doFinished = new Runnable()
    {
      public void run()
      {
        treePanel.setDocument(doc2);
      }
    };
    SwingUtilities.invokeLater(doFinished);
  }}