/*
 * User: eoliveira
 * Date: 01/07/2002
 * Time: 08:53:46
 */

import java.util.*;

final public class RepTimer {
   private long start;
   private long end;
   static String DATE_FORMAT = "HH:mm:ss";
   static java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(DATE_FORMAT);

   public RepTimer()
   {
	 reset();
	 /*
	 ** on some JDK, the default TimeZone is wrong
	 ** we must set the TimeZone manually!!!
	 **     sdf.setTimeZone(TimeZone.getTimeZone("EST"));
	 */
	 sdf.setTimeZone(TimeZone.getDefault());


   }

   public void start()
   {
	 System.gc();
	 start = System.currentTimeMillis();
   }

   public void end()
   {
	 System.gc();
	 end = System.currentTimeMillis();
   }

   public long duration()
   {
	 return (end-start);
   }

   public void reset()
   {
	 start = 0;  end   = 0;
   }

   static public String getTime()
   {
	 return sdf.format(Calendar.getInstance().getTime());
   }

   public String getTime(long milis)
   {
	 return sdf.format(new Date(milis));
   }

   public String getTime(Date date)
   {
	 return sdf.format(date);
   }

   static public String TimeTicksToString(long ttics)
   {
	 ttics /= 100;
	 long days = ttics / 86400;
	 ttics -= days * 86400;
	 long hours = ttics / 3600;
	 ttics -= hours * 3600;
	 long mins = ttics / 60;
	 long sec = ttics % 60;
	 return new String(""+days+" dias, "+hours+" horas, "+mins+" minutos, "+sec+" segundos");
   }
}