import java.io.Writer;
import java.util.Enumeration;
import java.util.Vector;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.TreeNode;
import javax.swing.tree.MutableTreeNode;
import com.sun.xml.tree.ElementNode;
import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.Text;

public class ShowElement extends ElementNode implements MutableTreeNode {
  boolean updated = false;
  protected MutableTreeNode treeNodeParent = null;
  JDrawPanel drawPanel = null;
  protected JLabel childComp;
  protected JLabel fatherComp;
  JDialog dialog = null;
  JLabel lblHtml = null;
  JTextArea lblLog = null;
  JFrame frame = null;
  private JPanel lastPanelDrawn = null;
  TreeModelListener listener = null;
  public void draw()
  {
    if (lastPanelDrawn != null)
      draw(listener, lastPanelDrawn);
  }  
  public void insert(MutableTreeNode child, int index)
  {
    //System.out.println("insert "+child.toString());
    if (!(child instanceof ElementNode))
      return;
    if (item(index) != null)
      insertBefore((ElementNode) child, item(index));
    else
      appendChild((ElementNode) child);
  }  ;
  public void remove(int index)
  {
    //System.out.println("Remove "+index);
    removeComponent((ShowElement) item(index));
    removeChild(item(index));
  }  ;
  public void removePanel()
  {
    for (ShowElement el = (ShowElement) getFirstChild();
         el != null;
         el = (ShowElement) el.getNextSibling())
    {
      el.removePanel();
    }
    if (drawPanel != null && lastPanelDrawn != null)
    {
      lastPanelDrawn.remove(drawPanel);
    }
  }  
  public void removeComponent(ShowElement e)
  {
    if (drawPanel != null)
    {
      //System.out.println("Removendo componente: "+e.toString());
      drawPanel.remove(e.getChildComponent());
    }
    e.removePanel();
  }  
  public void remove(MutableTreeNode node)
  {
    //System.out.println("Remove "+node.toString());
    if (!(node instanceof ElementNode))
      return;
    removeComponent((ShowElement) node);
    removeChild((ElementNode) node);
  }  ;
  public void removeFromParent()
  {
    //System.out.println("Remove From parent");
    if (getParent() instanceof ElementNode)
    {
      getParentNode().removeChild(this);
    }
    else
    {
      ((MutableTreeNode) getParent()).remove(this);
    }
  }  ;
  public ImageIcon getIcon()
  {
    return new ImageIcon("images/compfolder.gif");
  }  
  JLabel createComp()
  {
    JLabel comp = new JLabel(getIcon());
    comp.setForeground(Color.yellow);
    comp.setToolTipText(getToolTip());
    comp.setVerticalTextPosition(JLabel.BOTTOM);
    comp.setHorizontalTextPosition(JLabel.CENTER);
    comp.addMouseListener(new MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        ShowElement.this.mouseClicked(e);
      }
    });
    return comp;
  }

  String getHTMLAttributes()
  {
    String ret = new String();
    ret += "<html><body><table border=1>\n";
    NamedNodeMap attrMap = getAttributes();
    for (int i = 0; i < attrMap.getLength(); i++)
    {
      String nome = attrMap.item(i).getNodeName();
      ret += "<tr><td><b><font color=blue>"
              + nome
              + "</font></b></td><td>"
              + attrMap.item(i).getNodeValue()
              + "</td></tr>\n";
    }
    //String conteudo = getConteudo();
    //if (conteudo != null)
    //ret += "<tr><td><b><font color=blue>Contedo</font></b></td><td>"+conteudo+"</td></tr>\n";
    ret += "</table></body></HTML>";
    return ret;
  }
  public String getConteudo()
  {
    //System.out.println(getNome() + ": contedo solicitado. " + (conteudo != null));

    return conteudo;
  }
  void mouseClicked(MouseEvent e)
  {
    if (e.getClickCount() == 2 && getChildCount() > 0)
    {

      if (listener != null)
      {
        TreeModelEvent e1 = new TreeModelEvent(this, getPath());
        listener.treeNodesChanged(e1);
      }
    }
    else if ((e.getModifiers() != MouseEvent.BUTTON1_MASK) || (getChildCount() == 0))
    {
      showDetailDialog((JComponent)e.getSource());
    }
  }
  public void addTreeModelListener(TreeModelListener l)
  {
    listener = l;
  }  
  protected TreeNode[] getPathToRoot(TreeNode aNode, int depth)
  {
    TreeNode[] retNodes;
    /* Check for null, in case someone passed in a null node, or
    they passed in an element that isn't rooted at root. */
    if (aNode == null)
    {
      if (depth == 0)
        return null;
      else
        retNodes = new TreeNode[depth];
    }
    else
    {
      depth++;
      retNodes = getPathToRoot(aNode.getParent(), depth);
      retNodes[retNodes.length - depth] = aNode;
    }
    return retNodes;
  }  
  public TreeNode[] getPath()
  {
    return getPathToRoot(this, 0);
  }
  public JComponent createChildComponent()
  {
    childComp = createComp();
    childComp.setToolTipText(getToolTip());
    childComp.setText(toString());
    return childComp;
  }
  public JComponent createFatherComponent()
  {
    fatherComp = createComp();
    fatherComp.setToolTipText(getToolTip());
    fatherComp.setText(toString());
    return fatherComp;
  }
  public JComponent getChildComponent()
  {
    return childComp;
  }  
  public String getNome()
  {
    return getTagName() + " " + getAttribute("Nome");
  }
  public String getToolTip()
  {
    return toString() + ": " + getAttribute("Status");
  }
  public Enumeration children()
  {
    System.out.println("ShowElement.children()");
    throw new RuntimeException("NYI(Not Yet Implemented)");
  }  
  public void setParent(MutableTreeNode newParent)
  {
    treeNodeParent = newParent;
  }  ;
  public void setUserObject(Object object)
  {
  }  ;
  public ShowElement()
  {
  }  ;
  public void draw(TreeModelListener l, JPanel panel)
  {
    listener = l;
    lastPanelDrawn = panel;
    if (drawPanel == null)
    {
      drawPanel = new JDrawPanel();
      fatherComp = (JLabel) createFatherComponent();
      drawPanel.add(fatherComp, CircleLayout.CENTRO);
      panel.add(toString(), drawPanel);
    }
    for (ShowElement el = (ShowElement) getFirstChild();
         el != null;
         el = (ShowElement) el.getNextSibling())
    {
      if (el.getChildComponent() == null)
      {
        el.addTreeModelListener(listener);
        drawPanel.add(el.createChildComponent());
      }
    }
    ((CardLayout) panel.getLayout()).show(panel, toString());
  }  
  // used by JTree to display this node
  public String toString()
  {
    StringBuffer value = new StringBuffer();
    value.append('<');
    value.append(getTagName());
    value.append(getAttributes().toString());
    value.append('>');
    return value.toString();
  }  
  // TreeNode method implementations
  public TreeNode getChildAt(int n)
  {
    Node node = item(n);
    //System.out.println("getChildAt "+n+", tipo : "+node.getNodeType());
    if (node instanceof TreeNode)
      return (TreeNode) node;
    // Text, ProcessingInstruction ...
    System.out.println("Retornando node default como filho ");
    return new MaskedNode(node);
  }  
//
// In this case we really _do_ want to show all the internal
// nodes, so we really ought to use custom TreeNode and
// ProcessingInstruction classes as we build.
//
  static class MaskedNode implements TreeNode {
    private Node real;
    MaskedNode(Node e)
    {
      real = e;
    }
    public int getChildCount()
    {
      return 0;
    }
    public TreeNode getChildAt(int n)
    {
      return null;
    }
    public TreeNode getParent()
    {
      return (TreeNode) real.getParentNode();
    }
    public int getIndex(TreeNode node)
    {
      return -1;
    }
    public boolean getAllowsChildren()
    {
      return false;
    }
    public boolean isLeaf()
    {
      return true;
    }
    public Enumeration children()
    {
      return null;
    }
    public String toString()
    {
      if (real instanceof Text)
      {
        System.out.println("Real instanceof Text");
        return real.toString(); // XXX constructor
      }
      if (real instanceof ProcessingInstruction)
      {
        System.out.println("Real Processin Insctruction");
        return real.toString(); // XXX constructor
      }
      return "... ? ...";
    }
  }
  public int getChildCount()
  {
    return getLength();
  }  
  public TreeNode getParent()
  {
    //return treeNodeParent;
    return (TreeNode) getParentNode();
  }  
  public int getIndex(TreeNode node)
  {
    if (node instanceof ElementNode)
      return getIndexOf((ElementNode) node); // XXX implement
    else
      return -1;
  }  
  public boolean getAllowsChildren()
  {
    return true;
  }  
  public boolean isLeaf()
  {
    // System.out.println(this.toString()+": isleaf = "+(!hasChildNodes())+" childcount = "+getLength());
    return !hasChildNodes();
  }
  /**
   * Prune out various play elements we don't really want
   * to be displaying though swing.JTree ...
   */
  public Node appendChild(Node n) throws DOMException
  {
    if (n instanceof ShowElement)
    {
      return super.appendChild(n);
    }
    else
    {
      //System.out.println(getNome() + " Node  no  ShowElement: " + n.getNodeValue());
      String nodeValue = n.getNodeValue().replace('+', '\n');
      String conteudo = getConteudo();
      if (conteudo == null)
        conteudo = nodeValue;
      else
        conteudo += nodeValue;
      while (conteudo != null && conteudo.endsWith("\n"))
        if (conteudo.length() > 1)
          conteudo = conteudo.substring(0, conteudo.length() - 1);
        else
          conteudo = null;
      setConteudo(conteudo);
    }
    return n;
  }
  public ShowElement appendCloneChild(ElementNode n) throws DOMException {
    ShowElement retval;
    retval = (ShowElement) getOwnerDocument().createElement(n.getTagName());
    NamedNodeMap attrMap = n.getAttributes();
    if (attrMap != null)
    {
      for (int i = 0; i < attrMap.getLength(); i++)
      {
        String nome = attrMap.item(i).getNodeName();
        retval.setAttribute(nome, attrMap.item(i).getNodeValue());
      }
    }
    for (int i = 0; true; i++)
    {
      Node node = n.item(i);
      if (node == null)
        break;
      if (node instanceof ElementNode)
        retval.appendCloneChild((ElementNode) node);
    }
    retval.updated = true;
    appendChild(retval);
    return retval;
  }  
  public boolean equals(ShowElement e)
  {
    return e.getNodeName().equals(getNodeName())
            && e.getAttribute("Nome").equals(getAttribute("Nome"));
  }
  public boolean updateChildren(ShowElement e)
  {
    boolean atualizar = false;
    for (ShowElement el = (ShowElement) getFirstChild();
         el != null;
         el = (ShowElement) el.getNextSibling())
      el.updated = false;
    for (int i = 0; i < e.getChildCount(); i++)
    {
      ShowElement elNovo = (ShowElement) e.item(i);
      ShowElement el = (ShowElement) item(i);
      if (el != null && el.equals(elNovo))
      {
        atualizar = el.update(elNovo) || atualizar;
      }
      else
      {
        boolean achou = false;
        for (el = (ShowElement) getFirstChild();
             el != null;
             el = (ShowElement) el.getNextSibling())
        {
          if (el.equals(elNovo))
          {
            atualizar = el.update(elNovo) || atualizar;
            achou = true;
            break;
          }
        }
        if (!achou)
        {
          appendCloneChild(elNovo);
          // Vamos testar no atualizar a rvore quando um n for inserido
          atualizar = true;
        }
      }
    }
    for (ShowElement el = (ShowElement) getFirstChild(); el != null;)
      if (!el.updated)
      {
        //System.out.println("Removendo "+el.toString());
        ShowElement tmp = el;
        el = (ShowElement) el.getNextSibling();
        remove(tmp);
        atualizar = true;
      }
      else
        el = (ShowElement) el.getNextSibling();
    if (atualizar && fatherComp != null)
      drawPanel.updateSize();
    return atualizar;
  }
  public synchronized boolean update(ShowElement e)
  {
    //System.out.println("Atualizando "+getNome()+" a partir de "+e.getNome());
    updated = true;
    //System.out.println(this.toString()+" Update "+e.toString()+": isleaf = "+(!hasChildNodes())+" childcount = "+getLength());
    NamedNodeMap attrMap = e.getAttributes();
    for (int i = 0; i < attrMap.getLength(); i++)
    {
      String nome = attrMap.item(i).getNodeName();
      setAttribute(nome, attrMap.item(i).getNodeValue());
    }
    setConteudo(e.getConteudo());
    if (fatherComp != null)
    {
      fatherComp.setToolTipText(getToolTip());
      //fatherComp.setText(toString());

    }
    if (childComp != null)
    {
      childComp.setToolTipText(getToolTip());
      //childComp.setText(toString());
    }
    if (lblHtml != null)
    {
      String htmlText = getHTMLAttributes();
      String conteudo = getConteudo();
      if (htmlText.compareTo(lblHtml.getText()) != 0)
      {
        lblHtml.setText(htmlText);
        if (lblLog != null)
        {
          lblLog.setText(conteudo);
          lblLog.setCaretPosition(0);
        }
      }
      if (lblLog == null && conteudo != null)
        createConteudoLbl(conteudo);
    }
    return updateChildren(e);
  }

  String conteudo = null;void createConteudoLbl(String conteudo)
  {
    lblLog = new JTextArea(conteudo);
    //lblLog.setFont(new Font("Serif", Font.ITALIC, 16));
    lblLog.setCaretPosition(0);
    //lblLog.setLineWrap(true);
    lblLog.setWrapStyleWord(true);
    JScrollPane areaScrollPane = new JScrollPane(lblLog);
    areaScrollPane.setVerticalScrollBarPolicy(
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    //areaScrollPane.setPreferredSize(new Dimension(250, 250));
    int h1 = 50;
    int h2 = 200;
    int prefHeight = lblLog.getPreferredScrollableViewportSize().height;
    int h = prefHeight < h1 ? h1 : prefHeight > h2 ? h2 : h2;
    areaScrollPane.setPreferredSize(new Dimension(250, h));
    Container contentPane = dialog.getContentPane();
    contentPane.add(areaScrollPane, BorderLayout.SOUTH);
    dialog.setSize(
            lblHtml.getPreferredSize().width + 20,
            dialog.getPreferredSize().height + 50);
  }

  protected void setConteudo(String conteudo)
  {
    //System.out.println(getNome() + ": contedo setado. " + (conteudo != null));
    this.conteudo = conteudo;
  }

  void showDetailDialog(JComponent c)
  {
    if (dialog == null)
    {
      dialog = new JDialog(frame, toString());
      //Add contents to it.
      lblHtml = new JLabel(getHTMLAttributes());
      lblHtml.setHorizontalAlignment(JLabel.LEFT);
      lblHtml.setVerticalAlignment(JLabel.CENTER);
      Container contentPane = dialog.getContentPane();
      contentPane.add(lblHtml, BorderLayout.CENTER);
      String conteudo = getConteudo();
      if (conteudo != null)
        createConteudoLbl(conteudo);
      int max = 600;
      int width = lblHtml.getPreferredSize().width + 20;
      if (width > max)
        width = max;
      dialog.setSize(width, dialog.getPreferredSize().height + 50);
    }
    dialog.setLocationRelativeTo(c);
    dialog.setVisible(true);
  }
}