import java.awt.Component;
import java.awt.Dimension;
import java.awt.CardLayout;

import javax.swing.AbstractAction;
import javax.swing.JTree;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.ImageIcon;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;

//import javax.swing.tree.;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultTreeModel;

import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;

import com.sun.xml.tree.XmlDocument;
import com.sun.xml.tree.TreeWalker;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

// modeled after Java Tutorial's TreeDemo
public class TreePanel extends JSplitPane
        implements TreeSelectionListener, TreeModelListener
{
  private JTree   tree;
  private JPanel panel;
  private AbstractAction []actvEntityTypeActions;
  private AbstractAction []actvEntityActions;
  private AbstractAction []actvParameterActions;
  private AbstractAction []actvEntityTypesActions;
  private AbstractAction []actvEntitiesActions;
  private AbstractAction []actvParametersActions;

  void setDocument(XmlDocument doc)
  {
    if (doc == null) return;
    Element   root = doc.getDocumentElement ();
    root.normalize();

    ShowElement nodeRaizDoc = getNodeRaiz(root.getAttribute("Nome"));
    if (nodeRaizDoc != null)
    {
      if (nodeRaizDoc.update((ShowElement)root))
      {
        //System.err.println("Reloading tree");
        //((DefaultTreeModel)tree.getModel()).reload();
        ((DefaultTreeModel)tree.getModel()).nodeStructureChanged(nodeRaizDoc);
      }
    }
    else
    {
      addDocument(doc);
    }
    valueChanged(null);
  }

  ShowElement getNodeRaiz(String nome)
  {
    DefaultTreeModel treeModel = (DefaultTreeModel)tree.getModel();
    DefaultMutableTreeNode rootNode = (DefaultMutableTreeNode)treeModel.getRoot();
    ShowElement nodeRaizDoc = null;
    for (int i = 0; i < rootNode.getChildCount(); i++)
    {
      ShowElement node = (ShowElement)rootNode.getChildAt(i);
      String nodeNome = node.getAttribute("Nome");
      if (nome.equals(nodeNome))
      {
        nodeRaizDoc = node;
        break;
      }
    }
    return nodeRaizDoc;
  }

  public void treeNodesChanged(TreeModelEvent e)
  {
    if (e.getSource() instanceof ShowElement)
    {
      //DefaultTreeModel model = (DefaultTreeModel)tree.getModel();
      //TreePath tp = new TreePath(model.getPathToRoot((ShowElement)e.getSource()));
      TreePath tp = new TreePath(e.getPath());
      tree.getSelectionModel().setSelectionPath(tp);
    }
  }  
  public void treeNodesInserted(TreeModelEvent e)  {  }  
  public void treeNodesRemoved(TreeModelEvent e) { }  
  public void treeStructureChanged(TreeModelEvent e) { }


  void addDocument(XmlDocument doc)
  {
    if (doc == null) return;
    Element   root;
    root = doc.getDocumentElement ();
    root.normalize();

    //System.out.println(root.toString()+", "+root.getChildNodes().getLength()+" filhos");
    DefaultTreeModel treeModel = (DefaultTreeModel)tree.getModel();
    DefaultMutableTreeNode rootNode = (DefaultMutableTreeNode)treeModel.getRoot();

    treeModel.insertNodeInto((MutableTreeNode)root, rootNode,0);
    TreeNode []aNodes = { rootNode, (MutableTreeNode)root };
    tree.scrollPathToVisible(new TreePath(aNodes));
  }

  void setEntityActions(AbstractAction [] controllerAction)
  {
    actvEntityActions = controllerAction;
  }

  void setEntityTypeActions(AbstractAction [] DcmSapAction)
  {
    actvEntityTypeActions = DcmSapAction;
  }

  void setParameterActions(AbstractAction [] controllerAction)
  {
    actvParameterActions = controllerAction;
  }

  void setEntitiesActions(AbstractAction [] controllerAction)
  {
    actvEntitiesActions = controllerAction;
  }

  void setEntityTypesActions(AbstractAction [] DcmSapAction)
  {
    actvEntityTypesActions = DcmSapAction;
  }

  void setParametersActions(AbstractAction [] controllerAction)
  {
    actvParametersActions = controllerAction;
  }

  TreePanel (XmlDocument doc)
  {
    super (JSplitPane.HORIZONTAL_SPLIT);

    setDividerSize(4);
    setBorder (BorderFactory.createEmptyBorder (3, 3, 3, 3));

    panel = new JPanel();
    panel.setLayout(new CardLayout());
    /*
    panel.setBorder (BorderFactory.createEmptyBorder (8, 8, 8, 8));
    CircleLayout lay = new CircleLayout(panel);
    panel.setLayout(lay);
    ImageIcon icon = new ImageIcon("images/Coletor2.gif");
    panel.add(new JButton("Um"),CircleLayout.CENTRO);
    for (int i = 0 ; i < 25 ; i ++)
    {
    JLabel teste = new JLabel(icon);
    teste.setToolTipText("Apenas testando...");
    panel.add(teste);
    }
    panel.setMinimumSize(lay.minimumLayoutSize(panel));
    panel.setPreferredSize(lay.preferredLayoutSize(panel));
    panel.setBackground(Color.black);
    */
    DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("Root");
    TreeModel model = new DefaultTreeModel(rootNode);
    tree = new JTree(model);
    tree.setRootVisible(false);
    tree.setShowsRootHandles(true);

    setDocument(doc);
    tree.setCellRenderer(new MyRenderer());
    tree.getSelectionModel ()
            .setSelectionMode (TreeSelectionModel.SINGLE_TREE_SELECTION);
    tree.addTreeSelectionListener (this);

    // The right pane is used to render each scene.
    JScrollPane   treeView,compView;

    setLeftComponent (treeView = new JScrollPane (tree));
    setRightComponent (compView = new JScrollPane (panel));
    //setRightComponent (panel);
    Dimension minimumSize = new Dimension (100, 50);
    treeView.setMinimumSize (minimumSize);

    setPreferredSize (new Dimension (780, 580));
    setDividerLocation (250);
  }

  void enableEntityTypeActions(boolean en,EntityTypeElement ce)
  {
    if (actvEntityTypeActions == null) return;
    actvEntityTypeActions[0].setEnabled(en);
  }

  void enableEntityActions(boolean en,EntityElement ce)
  {
    if (actvEntityActions == null) return;
    actvEntityActions[0].setEnabled(en);
  }

  void enableParameterActions(boolean en,ParameterElement de)
  {
    if (actvParameterActions == null) return;
    actvParameterActions[0].setEnabled(en);
  }

  void enableEntityTypesActions(boolean en,EntityTypesElement ce)
  {
    if (actvEntityTypeActions == null) return;
    actvEntityTypesActions[0].setEnabled(en);
  }

  void enableEntitiesActions(boolean en,EntitiesElement ce)
  {
    if (actvEntitiesActions == null) return;
    actvEntitiesActions[0].setEnabled(en);
  }

  void enableParametersActions(boolean en,ParametersElement de)
  {
    if (actvParametersActions == null) return;
    actvParametersActions[0].setEnabled(en);
  }

  public ShowElement getSelected()
  {
    TreePath  path = tree.getSelectionPath ();
    Object  selected;

    if (path == null) // rm selection
      return null;
    selected = path.getLastPathComponent ();
    if (selected instanceof ShowElement)
      return (ShowElement)selected;
    return null;
  }

  public ShowElement getRootSelected()
  {
    TreePath  path = tree.getSelectionPath ();
    Object  selected;

    if (path == null) // rm selection
      return null;
    selected = path.getPathComponent(1);
    if (selected instanceof ShowElement)
      return (ShowElement)selected;
    return null;
  }

  public void valueChanged (TreeSelectionEvent e)
  {
    TreePath  path = tree.getSelectionPath ();
    Object  selected;

    if (path == null) // rm selection
      return;
    selected = path.getLastPathComponent ();
    if (selected instanceof ShowElement)
      ((ShowElement)selected).draw(this,panel);
    if (selected instanceof EntityElement)
    {
      enableEntityActions(true,(EntityElement)selected);
      enableParameterActions(false,null);
      enableEntityTypeActions(false,null);
    }
    else if (selected instanceof EntityTypeElement)
    {
      enableEntityTypeActions(true,(EntityTypeElement)selected);
      enableEntityActions(false,null);
      enableParameterActions(false,null);
    }
    else if (selected instanceof ParameterElement)
    {
      enableParameterActions(true,(ParameterElement)selected);
      enableEntityActions(false,null);
      enableEntityTypeActions(false,null);
    }
    else
    {
      enableEntityActions(false,null);
      enableParameterActions(false,null);
      enableEntityTypeActions(false,null);
    }
  }

  private class MyRenderer extends DefaultTreeCellRenderer
  {
    ImageIcon EntityIcon;
    ImageIcon EntityTypeIcon;
    ImageIcon ParameterIcon;
    ImageIcon EntitiesIcon;
    ImageIcon EntityTypesIcon;
    ImageIcon ParametersIcon;
    ImageIcon EntRepBrowserIcon;

    public MyRenderer()
    {
      EntityIcon = new ImageIcon("images/entity.gif");
      EntityTypeIcon = new ImageIcon("images/entitytype.gif");
      EntitiesIcon = new ImageIcon("images/entities.gif");
      ParameterIcon = new ImageIcon("images/parameter.gif");
      ParametersIcon = new ImageIcon("images/parameters.gif");
      EntityTypesIcon = new ImageIcon("images/entitytypes.gif");
      EntRepBrowserIcon = new ImageIcon("images/entrepbrowser.gif");

      if (EntRepBrowserIcon == null)
      {
        System.out.println("No achei icones...");
      }
    }

    public Component getTreeCellRendererComponent(
            JTree tree,
            Object value,
            boolean sel,
            boolean expanded,
            boolean leaf,
            int row,
            boolean hasFocus)
    {
      super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
      if (value  instanceof EntRepElement)
        setIcon(EntRepBrowserIcon);
      if (value  instanceof EntitiesElement)  setIcon(EntitiesIcon);
      if (value  instanceof ParameterElement) setIcon(ParameterIcon);
      if (value  instanceof ParametersElement)setIcon(ParametersIcon);
      if (value  instanceof EntityElement)     setIcon(EntityIcon);
      if (value  instanceof EntityTypeElement) setIcon(EntityTypeIcon);
      if (value  instanceof EntityTypesElement)setIcon(EntityTypesIcon);
      return this;
    }
  }

  public void removeSubTree(String rootName)
  {
    System.out.println("Removendo subtree: "+rootName);
  }
}