
package EventEvaluator.Interation.Evaluators;

import java.util.*;
import java.lang.*;
import java.io.*;
import java.sql.Timestamp;

public abstract class Evaluator extends Thread {

    private EventEvaluator.Interation.Notifier notifier;
    private EventEvaluator.Interation.Frequency fobj;
    private EventEvaluator.Interation.Suspend se;

    public Evaluator (EventEvaluator.Interation.Notifier pn,
		      EventEvaluator.Interation.Frequency pf, 
		      EventEvaluator.Interation.Suspend ps) {  
	this.notifier = pn;
	this.fobj = pf;
	this.se = ps;
    }

    // to be overriden by user code
    abstract String user_evaluation_code();

    public void execute_evaluation () {
	String event = user_evaluation_code();
	// if event occured, do notification
	if (event != null)
	    notifier.notify (event);
    }

    public void run() {
	do {
	    // check if the monitor must suspend its execution
	    se.is_suspended();
	    // execute evaluation
	    execute_evaluation();
	    // wait for next interation
	    try {
		Thread.sleep(fobj.get()*1000);
	    }
	    catch (InterruptedException e) {
		System.err.println(e.toString());
	    }	
	}
	while(true);
    }

} // end class SampleEvaluator


