/*
 * InterationEventImpl
 * Version 1.0
 */
package EventEvaluator.Interation;

import java.util.*;
import java.lang.*;
import java.io.*;

import org.omg.PortableServer.*;
import org.omg.CosNaming.*;

/** 
 * Implements the EventEvaluator/Interation/InterationEvent interface.
 *
 * @author Francisco Silva
 * @version 1.0
 */
public class InterationEventImpl extends InterationEventPOA {
    private String eid;                 // interation event id
    private String strIOR;              // stringfied ior 
    private String description;         // description
    private int    frequency;;
    private String class_name;
    org.omg.CORBA.ORB orb;              // orb reference
    Persistence pobj;                   // persistence object

    public InterationEventImpl(String eid, org.omg.CORBA.ORB orb, Persistence pobj)
    {
	this.eid = eid;
	this.orb = orb;
	this.pobj = pobj;
	Object state[] = new Object[5];
	state = pobj.IELoadState(eid);
	this.eid = (String)state[0];
	this.strIOR = (String)state[1];
	this.description = (String)state[2];
	class_name = new String();
	class_name = (String)state[3];
	Integer ifrequency = new Integer((String)state[4]);
	this.frequency = ifrequency.intValue();
    }

    // the methods eid() and description() are derived from
    // Event interface

    /**
     * Returns the identification of this interation event.
     * @return the identification of this interation event
     */
    public String eid() {
	return this.eid;
    }

    /**
     * Returns the description of this interation event.
     * @return the description of this interation event
     */
    public String description() {
	return this.description;
    }

    // the methods frequency(), class_name()
    // are derived from InterationEvent interface

    public int frequency() {
	return this.frequency;
    }

    public String class_name() {
	return this.class_name;
    }

} // end class InterationEventImpl
