package EventEvaluator.Interation;

import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.InetAddress;
import java.sql.Timestamp;

import org.omg.PortableServer.*;

public class InterationManagerImpl extends InterationManagerPOA {

    private org.omg.CORBA.ORB orb;
    private POA the_poa; 
    private InterationEventRepository ie_r;
    
    private Hashtable TBEvaluators;
    private Notifier notifierThread;

    private Utilities.GeraArq arqLog = null;
    private String hostName = new String();
    private boolean salvaProfile = true;

    public InterationManagerImpl(org.omg.CORBA.ORB orb, POA the_poa,  
				 InterationEventRepository ie_r ) {
	this.orb = orb;
	this.the_poa = the_poa;
	this.ie_r = ie_r;

	// creating data-structures
	TBEvaluators = new Hashtable();
	
	// creating auxiliary objects
	notifierThread = new Notifier(orb);
	notifierThread.start();
    }

    public void register(InterationEvent ie) throws EventEvaluator.EventClassNotFound {
	String eid = ie.eid();
	// check if event is already beeing evaluated
	ActiveEvent ae = (ActiveEvent) TBEvaluators.get(eid);
	if (ae != null) {
	    // nothing to do
	    return;
	}
	try {
	    ActiveEvent nae = new ActiveEvent(ie, notifierThread);
	    TBEvaluators.put(eid, nae);
	    System.out.println("Event "+ie.eid()+" now beeing evaluated !");
	}
	catch (EventEvaluator.EventClassNotFound ecnf) {
	    throw ecnf;
	}
	catch (NoSuchMethodException nsme) {
	}
    }

    public void unregister(String eid) 
	throws EventEvaluator.NoSuchEvent, EventEvaluator.EventNotBeeingEvaluated {
	try {
	    // check if event exist
	    InterationEvent ie = ie_r.get_ie_ref (eid);
	}
	catch (EventEvaluator.NoSuchEvent nse) {
	    throw (nse);
	}
	// check if event is beeing evaluated
	ActiveEvent ae = (ActiveEvent) TBEvaluators.get(eid);
	if (ae == null) {
	    throw new EventEvaluator.EventNotBeeingEvaluated(eid);
	}
	// remove event from Hastable
	TBEvaluators.remove(eid);
	ae = null;
	System.out.println("Event "+eid+" NOT beeing evaluated anymore !");	
    }
    
    public void suspend(String eid) 
	throws EventEvaluator.NoSuchEvent, EventEvaluator.EventNotBeeingEvaluated {
	try {
	    // check if event exist
	    InterationEvent ie = ie_r.get_ie_ref (eid);
	}
	catch (EventEvaluator.NoSuchEvent nse) {
	    throw (nse);
	}
	// check if event is beeing evaluated
	ActiveEvent ae = (ActiveEvent) TBEvaluators.get(eid);
	if (ae == null) {
	    throw new EventEvaluator.EventNotBeeingEvaluated(eid);
	}
	// suspend event evaluation
	if (ae.is_suspended() == false) {
	    ae.suspend();
	    System.out.println("Event "+eid+" evaluation suspended !");	
	}
    }

    public void resume(String eid) 
	throws EventEvaluator.NoSuchEvent, EventEvaluator.EventNotBeeingEvaluated {
	try {
	    // check if event exist
	    InterationEvent ie = ie_r.get_ie_ref (eid);
	}
	catch (EventEvaluator.NoSuchEvent nse) {
	    throw (nse);
	}
	// check if event is beeing evaluated
	ActiveEvent ae = (ActiveEvent) TBEvaluators.get(eid);
	if (ae == null) {
	    throw new EventEvaluator.EventNotBeeingEvaluated(eid);
	}
	// resume event evaluation
	if (ae.is_suspended() == true) {
	    ae.resume();
	    System.out.println("Event "+eid+" evaluation resumed !");	
	}
    }

    public void change_frequency(String eid, int new_frequency) 
        throws EventEvaluator.NoSuchEvent, EventEvaluator.EventNotBeeingEvaluated {
	try {
	    // check if event exist
	    InterationEvent ie = ie_r.get_ie_ref (eid);
	}
	catch (EventEvaluator.NoSuchEvent nse) {
	    throw (nse);
	}
	// check if event is beeing evaluated
	ActiveEvent ae = (ActiveEvent) TBEvaluators.get(eid);
	if (ae == null) {
	    throw new EventEvaluator.EventNotBeeingEvaluated(eid);
	}
	ae.change_frequency(new_frequency);
	System.out.println("Event "+eid+" frequency changed to " + new_frequency+" !");	       
    }


} // end class InterationManagerImpl



