/*
 * Notifier
 * Version 1.0
 */

package EventEvaluator.Interation;

import java.util.*;
import java.lang.*;
import java.io.*;

import Utilities.Log;

import org.omg.CosNaming.*;

import EventEvaluator.Resource.NotifierPushSupplier;

/**
 * Notifies the occurence of events
 *
 * @author Francisco Silva
 * @version 1.0
 */
public class Notifier extends Thread {

    private org.omg.CORBA.ORB orb;
    private NotifierPushSupplier  pushNotifier;
    private Log logObj;

    public Notifier (org.omg.CORBA.ORB porb) {
	this.orb = porb;
	pushNotifier = new NotifierPushSupplier(orb);
	logObj = logObj.Instance();
    }

    /**
     * Notifies the occurence of events
     * @param list the list of events that occured
     */
    public synchronized void notify (String eid) {

	pushNotifier.notify(eid);
	if (logObj.logging()) {
	    String sts = new String("Event "+eid+" notified\n\n");
	    logObj.writeStr(sts);
	}
    }

} // end class Notifier





