package EventEvaluator.Resource;

import org.omg.CosEventChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.Any;

public class NotifierPushSupplier 
    extends PushSupplierPOA {
    
    private org.omg.CORBA.ORB orb;
    private ProxyPushConsumer proxyPushConsumer;

    public NotifierPushSupplier (org.omg.CORBA.ORB porb) {
	this.orb = porb;
	initialize();
    }

    private void initialize() {
	org.omg.CosEventChannelAdmin.EventChannel e = null;
	try {
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));	
	    e = EventChannelHelper.narrow(nc.resolve(nc.to_name("eventchannel.resource")));
	} 
	catch (Exception ex) 
	{ 
	    ex.printStackTrace();
	}			

	SupplierAdmin supplierAdmin = e.for_suppliers();
	proxyPushConsumer = 
	    supplierAdmin.obtain_push_consumer();
    }

    public void notify (String eventMsg) {
	Any event = orb.create_any();
	try {
	    event.insert_string(eventMsg);
	    proxyPushConsumer.push( event );
	} 
	catch (Disconnected d) {
	    d.printStackTrace();
	}       
    }

    public void disconnect_push_supplier() {}
    
} // end class NotifierPushSupplier
