package Monitor.Interation;

import org.omg.PortableServer.*;
import org.omg.CORBA.*;
import org.omg.CORBA.ORBPackage.*;
import org.omg.CosTransactions.*;
import org.omg.CosNaming.*;

import java.io.*;

public class ServerStoreDB {

    public static void main(String[] args) {
    	
	if (args.length != 0) {
	    System.out.println ("Use: jaco Monitor.Interation.ServerStoreDB");
	    System.exit(1);
	}

	try {
	    // obtain reference to orb
	    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);

	    // obtain reference to root poa
	    POA rootpoa = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
	    
	    // obtain reference to name service
	    NamingContextExt rootContext = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));
    
	    // instanciate the servant
	    StoreDBImpl servant = new StoreDBImpl();
	    org.omg.CORBA.Object o = servant._this_object(orb);
	
	    // create the Adaptacao context
	    NameComponent [] name = new NameComponent[1];
	    name[0] = new NameComponent("Adaptacao","context");	  

	    boolean contexto_existe = false;
	    NamingContextExt subContext = null;
	    System.out.println("Tentando criar contexto Adaptacao...");
	    try {   
		subContext =
		    NamingContextExtHelper.narrow(rootContext.bind_new_context(name));
	    }
	    catch (org.omg.CosNaming.NamingContextPackage.AlreadyBound ab) {
		System.out.println("Contexto Adaptacao ja existe...");
		contexto_existe = true;
	    }
  
	    if (contexto_existe)
		subContext =
		    NamingContextExtHelper.narrow(rootContext.resolve(name));
	    
	    // register the StoreDB object with the name service
	    NameComponent [] sname = new NameComponent[1];
	    sname[0] = new NameComponent("StoreDB","service");
	    subContext.rebind(sname, o);
	    
	    // activates the poaManager
	    rootpoa.the_POAManager().activate();

	    // wait for requests
	    orb.run();
	} 
	catch (Exception e) {
	    e.printStackTrace();
	}
    }
}	
