package Monitor.Interation;

import java.util.*;
import java.sql.*;
import java.io.*;
import java.lang.*;
import java.sql.Timestamp;

public class StoreDBImpl  extends StoreDBPOA {

    Connection cx = null;
    String url;

    public StoreDBImpl () {
    }

    private int connect (String dbmachine, String database, String user,
			 String password) { 
	System.out.println("loading mysql driver...");
	try {
	    Class.forName("org.gjt.mm.mysql.Driver");
	}
	catch (Exception e) {
	    System.out.println(e);
	    return -1;
	}	
	
	url = "jdbc:mysql://" + dbmachine + "/" + database;
	System.out.println("connecting to database: " + url + "...");	

        try {
            cx = DriverManager.getConnection(url,user,password);
        }
        catch (SQLException se) {
	    System.out.println("Error connecting to database "+url+"!");
	    System.out.println(se);
	    return -1;
	}
	return 1;
    }

    private void disconnect () {
	try {
	    cx.close();
	}        
	catch (SQLException se) {
	    System.out.println("Error disconnecting from database "+url+"!");
	    System.out.println(se);
	}	   
	System.out.println("Disconnected from database "+url+"!");
	url = "";
    }

    public void save(String dbmachine, String database, String table, 
		     String user,      String password, String[] attributes) {

	if (attributes.length == 0)
	    return;
	if (attributes.length%2 != 0) {
	    System.out.println("Wrong attribute list lenght !");
	    return;
	}

	int ret = connect (dbmachine, database, user, password);
	if (ret != 1)
	    return;

	String s = "insert into "+table+"values(";
	if ((attributes.length/2) > 1) 
	    for (int j = 0; j <= ((attributes.length/2)-1); j++)
		s = s + "?, "; 
	s = s + "?)";
	System.out.println ("String s = "+s);

	try {
	    java.sql.PreparedStatement ps = cx.prepareStatement(s);

	    Timestamp ts = new Timestamp(System.currentTimeMillis());
	    ps.setTimestamp(1,ts);
	    int cont = 2;
	    
	    for (int i = 0; i <= attributes.length; i++) {
		String type = attributes[i];
		if (type.equals ("TIMESTAMP") ) {
		    Long auxl = new Long(attributes[i+1]);
		    Timestamp aux = new Timestamp(auxl.longValue());
		    ps.setTimestamp(cont, aux);
		}
		else if (type.equals ("CHAR") ) {
		    ps.setString(cont, attributes[i+1]);
		}
		else if (type.equals ("VARCHAR") ) {
		    ps.setString(cont, attributes[i+1]);
		}
		else if (type.equals ("TEXT") ) {
		    ps.setString(cont, attributes[i+1]);
		}
		else if (type.equals ("INT") ) {
		    Integer aux = new Integer(attributes[i+1]);
		    ps.setInt(cont, aux.intValue());
		}
		else if (type.equals ("DOUBLE") ) {
		    Double aux = new Double(attributes[i+1]);
		    ps.setDouble(cont, aux.doubleValue());
		}
		else {
		    System.out.println("Wrong column type: "+type+" !");
		    disconnect();
		    return;
		}
		cont = cont + 1;
		i = i + 1;
	    }
	    ps.executeUpdate();
	    ps.close();	    
	    disconnect();
	} // end try
	catch (SQLException se) {
	    System.out.println("Error on method save(): ");
	    System.out.println(se);
	}
	
    } // end method save
    
} // end class StoreDBImpl
