/*
 * RmoMemoryImpl
 * Version 1.0
 */
package Monitor.Resource;

import MonitoredEntities.*;

import java.util.*;
import java.sql.*;
import java.lang.*;
import java.io.*;

import org.omg.PortableServer.*;

/** 
 * Creates the objects that compose the Memory RMO. 
 * @author Francisco Silva
 * @version 1.0
 */
public class RmoMemoryImpl extends RmoImpl {

    private MemoryMonitor monitorThread;

    /**
     * Create the objects that compose the Memory RMO by calling the <code>RmoImpl</code>
     * constructor and creates the thread responsible for monitoring free memory available.
     *
     * @param orb reference to the orb
     * @param root_poa reference to the root poa
     * @param me reference to the monitored entity
     * @param par refernce to the parameter being monitored
     * @param rManager reference to the event evaluator
     */    
    public RmoMemoryImpl(org.omg.CORBA.ORB orb, POA root_poa, Entity me, Parameter par,
			 EventEvaluator.Resource.ResourceManager rManager)
    {
	super(orb, root_poa, me, par, rManager);
	monitorThread = new MemoryMonitor(cr, fobj, smonitor);
    }

    /**
     * Starts the monitoring thread.
     */
    public void startMonitoring() {
	// begin the monitoring
	monitorThread.start();
    }

} // end class RmoMemoryImpl
