package Utilities.Calculadora;

import java.util.*;

interface FuncaoUnaria {
    double f(double x);
}

public class TabelaFuncoes {

    private static Map funcoes;
    static {
	funcoes = new HashMap();
	// Adicionam-se novas funcoes aqui, seguindo o modelo.
	funcoes.put("sin", new FuncaoUnaria() {
		public double f(double x) { return Math.sin(x); }
	    });
	funcoes.put("cos", new FuncaoUnaria() {
		public double f(double x) { return Math.cos(x); }
	    });
	funcoes.put("tan", new FuncaoUnaria() {
		public double f(double x) { return Math.tan(x); }
	    });
	funcoes.put("asin", new FuncaoUnaria() {
		public double f(double x) { return Math.asin(x); }
	    });
	funcoes.put("acos", new FuncaoUnaria() {
		public double f(double x) { return Math.acos(x); }
	    });
	funcoes.put("atan", new FuncaoUnaria() {
		public double f(double x) { return Math.atan(x); }
	    });
	funcoes.put("floor", new FuncaoUnaria() {
		public double f(double x) { return Math.floor(x); }
	    });
	funcoes.put("ceil", new FuncaoUnaria() {
		public double f(double x) { return Math.ceil(x); }
	    });
	funcoes.put("sqrt", new FuncaoUnaria() {
		public double f(double x) { return Math.sqrt(x); }
	    });
	funcoes.put("exp", new FuncaoUnaria() {
		public double f(double x) { return Math.exp(x); }
	    });
	funcoes.put("ln", new FuncaoUnaria() {
		public double f(double x) { return Math.log(x); }
	    });
	funcoes.put("drnd", new FuncaoUnaria() {
		public double f(double x) { return drnd(x); }
	    });
	funcoes.put("irnd", new FuncaoUnaria() {
		public double f(double x) { return irnd(x); }
	    });
    }

    static private double drnd(double x) {
	x = x >= 0.0 ? x : 0;
	return x * Math.random();
    }

    static private double irnd(double x) {
	x = x >= 0.0 ? x : 0;
	return Math.floor(Math.floor(x) * Math.random());
    }
    
    static public double calcula(String nome, double x) {
	return ((FuncaoUnaria) funcoes.get(nome)).f(x);
    }

    static public boolean contem(String nome) {
	return funcoes.containsKey(nome);
    }

    public static void main(String[] args) {
	Iterator it = funcoes.keySet().iterator();
	while (it.hasNext()) {
	    String funcao = (String) it.next();
	    System.out.println(funcao + " em 0.5 e: " + calcula(funcao, 0.5));
	}
    }
}
    
    
