package Utilities.Calculadora;

%%

%column 

%{
  private Yytoken token(int t) {
    if (t != TokenTipo.FIM)
      return new Yytoken(t,yytext());
    else
      return new Yytoken(t,"FIM");
  }

  public int yyGetCol() {return yycolumn;}
%}

Identificador = [:jletter:][:jletterdigit:]*

Numero = {FLit1}|{FLit2}|{FLit3}|{FLit4}
FLit1 = [0-9]+ \. [0-9]* {Expoente}?
FLit2 = \. [0-9]+ {Expoente}?
FLit3 = [0-9]+ {Expoente}
FLit4 = [0-9]+ {Expoente}?
Expoente = [eE] [+\-]? [0-9]+

FinaldeLinha = \r|\n|\r\n
Brancos     = [ \t\f]

%%

/* Pula brancos */
{Brancos}		{/* Ignora */}

{Numero}		{return token(TokenTipo.NUMERO);}

{Identificador} 	{
			  if (TabelaFuncoes.contem(yytext()))
			    return token(TokenTipo.FUNCAO);
			  else
			    return token(TokenTipo.VARIAVEL);
			}

"="			{return token(TokenTipo.ATRIBUI);}

/* Parenteses */
"("			{return token(TokenTipo.PAR_ESQ);}
")"			{return token(TokenTipo.PAR_DIR);}

/* Operadores */
"+"                     {return token(TokenTipo.MAIS);}
"-"                     {return token(TokenTipo.MENOS);}
"*"                     {return token(TokenTipo.VEZES);}
"/"		        {return token(TokenTipo.DIVIDIDO);}
">"                     {return token(TokenTipo.MAIOR);}
"<"                     {return token(TokenTipo.MENOR);}
">="                    {return token(TokenTipo.MAIOR_IG);}
"<="                    {return token(TokenTipo.MENOR_IG);}
"=="                    {return token(TokenTipo.IGUAL);}
"!="                    {return token(TokenTipo.DIFERENTE);}
"&&"			{return token(TokenTipo.ELOGICO);}
"||"			{return token(TokenTipo.OULOGICO);}
"!"			{return token(TokenTipo.NEGACAO);}

/* Final de arquivo marca o fim da expressao. */
<<EOF>>			{return token(TokenTipo.FIM);}

/* Erro */
.			{return token(TokenTipo.INVALIDO);}

