package Utilities; 

public class Console { 

   public static void printPrompt(String prompt) {  
      System.out.print(prompt + " ");
      System.out.flush();
   }

   public static String readString() {  
      int ch;
      String r = "";
      boolean done = false;
      while (!done) {  
	  try { 
	      ch = System.in.read();
	      if (ch < 0 || (char)ch == '\n')
		  done = true;
	      else
		  r = r + (char) ch;
	  }
	  catch(java.io.IOException e) {  
	      done = true;
	  }
      }
      return r;
   }

    public static String readString(String prompt) {  
      printPrompt(prompt);
      return readString();
    }
    
    public static char readChar (String prompt) {
	printPrompt(prompt); 
        return ((char) readString().charAt(0));
    }

    public static String readWord() {  
	int ch;
	String r = "";
	boolean done = false;
			
      while (!done) {  
	  try {  
	      ch = System.in.read();
	      if (ch < 0 || java.lang.Character.isSpace((char)ch))
		  done = true;
	      else
		  r = r + (char) ch;
	  }
	  catch(java.io.IOException e) {  
	      done = true;
	  }
      }
      return r;
    }
    
   public static int readInt(String prompt) {  
       while(true) {  
	   printPrompt(prompt);
	   try {  
	       return Integer.valueOf(readString().trim()).intValue();
	   } 
	   catch(NumberFormatException e) {  
	       System.out.println("Please, enter an integer number.");
	   }
       }
   }
    
   public static double readDouble(String prompt) {  
       while(true) {  
	   printPrompt(prompt);
         try {  
	     return Double.valueOf(readString().trim()).doubleValue();
         } 
	 catch(NumberFormatException e) {  
	     System.out.println ("Please, enter a double number.");
         }
       }
   }

    public static float readFloat (String prompt) {  
	while(true) {  
	    printPrompt(prompt);
	    try {  
		return Float.valueOf(readString().trim()).floatValue();
	    } 
	    catch(NumberFormatException e) {  
		System.out.println("Please, enter a float number.");
	    }
	}
    }
    
}
