package Utilities;

import java.io.*;
import java.util.*;

/** Classe LeArquivo
 * Le dados de um arquivo
 * Retorna lista de dados lidos
 * Imprime lista lida
 */
public class LeArquivo {

  private DataInputStream arq; 
  private Vector dados;
  private String nome_arq;
  private int quant;
  
  /** Construtor
   * @param nome do arquivo
   */
  public LeArquivo(String nome) {
    dados = new Vector();
    quant = 0;
    nome_arq = nome;
    le_arq();
    // imprime();
  }

  /** Abre o arquivo
   */
  private void abre_arq() {
    try {
      arq = new DataInputStream(new FileInputStream(nome_arq) );
    }
    catch ( IOException e ) {
      System.err.println( "Erro ao abrir arquivo\n" +
			  e.toString() );
      System.exit( 1 );
    }
  }

  /** Retorna os dados lidos do arquivo
   * @return relacao de dados lidos
   */
  public Vector retorna_dados() {
    return dados;
  }

  /** Retorna a quantidade de dados lidos
   * @return numero de dados lidos
   */
  public int retorna_quant() {
    return quant;
  }
  
  /** Realiza a leitura do arquivo
   */
  public synchronized void le_arq() {
    String um_dado;
    abre_arq();
    try {
      int i=0;
      // le as palavras constantes do arquivo
      while (true) {
	um_dado = arq.readUTF();
	// insere o dado no vetor
	// dados[i]=um_dado;
	dados.add(um_dado);
	i++;
	quant++;
      }
    }
    catch ( EOFException eof ) {
      fecha_arq();
    }
    catch ( IOException e ) {
      System.err.println( "Erro ao ler do arquivo\n" +
			  e.toString() );
      System.exit( 1 );
    }
  }

  /** Fecha o arquivo
   */
  private void fecha_arq() {
    try {
      arq.close();
    }
    catch ( IOException e ) {
      System.err.println( "Erro ao fechar arquivo\n" +
			  e.toString() );
      System.exit( 1 );
    }
  }
    
  /** Imprime o vetor de dados
   */
  public void imprime() {
      for (Enumeration e = dados.elements() ; e.hasMoreElements() ;) {
	  System.out.println(e.nextElement());
      }
  }
  
} // fim da classe LeArquivo   







