package Utilities;

import java.io.*;
import java.util.*;
import java.net.InetAddress;
import java.sql.Timestamp;

public class Log {

    private boolean log;
    private DataOutputStream arq; 
    private String hostName;
    private String applicationName;
    private int count;
    private static Log _instance = null;

    protected Log () {
	log = false;
	count = 0;
	hostName = new String();
	applicationName = new String();
	try{
	    InetAddress ia = InetAddress.getLocalHost();
	    hostName = ia.getHostName();
	}
	catch (java.net.UnknownHostException ue) {
	    System.out.println("Log.Log(): "+ue.toString());
	    hostName = "Unknown host name";
	}
    }

    public static Log Instance() {
	if (_instance == null)
	    _instance = new Log();
	return _instance;
    }

    public void setApplicationName(String pname) {
	applicationName = pname;
    }

    public void createFile(String arqName) {
	
	try{
	    this.arq = new DataOutputStream (new FileOutputStream (arqName, true));
	}
	catch (java.io.FileNotFoundException fnf) {
	    System.out.println("Log.createFile(): "+fnf.toString());
	}
	log = true;
    }   

    public boolean logging() {
	return log;
    }

    public void writeStr(String str) {
	if (log) {
	    try {
		Timestamp ts = new Timestamp(System.currentTimeMillis());
		arq.writeUTF("["+count+"] "+applicationName+" - "+hostName+" - "+
			     ts.toString()+"\n"+str+"\n");
		count = count + 1;
	    } 
	    catch ( EOFException eof ) {
		closeArq();
	    } 
	    catch ( IOException e ) {
		System.err.println("Log.writeStr(): " + e.toString());
	    }
	}
    }

    public void closeArq() {
	try {
	    arq.close();
	}
	catch ( IOException e ) {
	    System.err.println( "Log.closeArq(): " + e.toString());
	}
	log = false;
    }
    
} // fim da classe GeraArq










