package Utilities.iemClient;

import EventEvaluator.Interation.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class Client {
  
    private static org.omg.CORBA.ORB orb;

    private static InterationManager bindInterationManager() {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    InterationManager im = null;
	    NameComponent [] name = new NameComponent[2];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("InterationManager","service");
	    im = 
		InterationManagerHelper.narrow(nc.resolve(name));
	    return im;
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println("Could not bind to Interation Manager...");
	    System.exit(1);
	}
	return null;
    }

    private static InterationEventRepository bindIERepository() {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    InterationEventRepository ier = null;
	    NameComponent [] name = new NameComponent[2];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("InterationEventRepository","service");
	    ier = 
		InterationEventRepositoryHelper.narrow(nc.resolve(name));
	    return ier;
	}
	catch (Exception e) {
	    // e.printStackTrace();
	    System.out.println("Could not bind to Interation Event Repository...");
	    System.exit(1);
	}
	return null;
    }

    public static void main(String[] args) {
	String prompt = ">";

	// initialize 
	orb  = org.omg.CORBA.ORB.init(args, null);
	InterationManager im = bindInterationManager();
	InterationEventRepository ier = bindIERepository();

	Utilities.Console cs = new Utilities.Console();

	while (true) {
	    System.out.println("----------------------------------------------------------");
	    System.out.println("b-begin e-end s-suspend r-resume f-change frequency q-quit");
	    System.out.println("----------------------------------------------------------");
	    char op = cs.readChar(prompt);
	    if ((op=='Q')||(op=='q')) {
		System.out.println("Bye...");
		System.exit(0);
	    }
	    String eid = cs.readString("enter eid: ");
	    try {
		switch (op) {
		case 'B' : case 'b' :
		    InterationEvent ie = ier.get_ie_ref(eid);
		    im.register(ie);
		    break;	
		case 'E' : case 'e' :
		    im.unregister(eid);
		    break;	
		case 'S' : case 's' :
		    im.suspend(eid);
		    break;	
		case 'R' : case 'r' :
		    im.resume(eid);
		    break;	
		case 'F' : case 'f' :
		    int new_frequency = cs.readInt("enter new frequency: ");
		    im.change_frequency(eid, new_frequency);
		    break;	
		}	
	    }
	    catch (EventEvaluator.NoSuchEvent nse) {
		System.out.println(nse.toString());
	    }
	    catch (EventEvaluator.EventNotBeeingEvaluated enbe) {
		System.out.println(enbe.toString());
	    }
	    catch (EventEvaluator.EventClassNotFound ecnf) {
		System.out.println(ecnf.toString());
	    }
	}
    }
}



