package Utilities.omrClient;

import Monitor.Resource.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class Client {
  
    private static org.omg.CORBA.ORB orb;

    private static Rmo bind_omr(String strOmr) {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    Rmo omr = null;
	    NameComponent [] name = new NameComponent[3];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("Omr","context");
	    name[2] = new NameComponent(strOmr,"service");
	    omr = 
		RmoHelper.narrow(nc.resolve(name));
	    return omr;
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println("Could not bind to Rmo...");
	}
	return null;
    }

    public static void main(String[] args) {

	Rmo omr = null;
	String prompt = ">";

	// initialize 
	orb  = org.omg.CORBA.ORB.init(args, null);

	Utilities.Console cs = new Utilities.Console();

	while (true) {
	    System.out.println("--------------------------------");
	    System.out.println("c-connect s-suspend r-resume f-changeFreq");
	    System.out.println("v-showRange d-shutdown q-quitClient");
	    System.out.println("--------------------------------");
	    char op = cs.readChar(prompt);
	    switch (op) {
	    case 'C' : case 'c' :
		String strOmr = cs.readString("enter <meid>.<pid>: ");
		omr = bind_omr(strOmr);
		if (omr != null)
		    prompt = strOmr+">";
		else
		    prompt = ">";
		break;
	    case 'S' : case 's' :
		if (omr != null)
		    omr.suspend();
		break;
	    case 'R' : case 'r' :
		if (omr != null)
		    omr.resume();
		break;
	    case 'F' : case 'f' :
		if (omr != null) {
		    int nf = cs.readInt("enter new frequency: ");
		    omr.change_frequency(nf);
		}
		break;
	    case 'V' : case 'v' :
		if (omr != null) {
		    int value = omr.current_range();
		    System.out.println("Current range: "+value);
		}
		break;
	    case 'D' : case 'd' :
		if (omr != null) {
		    omr.shutdown();
		    omr = null;
		}
		break;
	    case 'Q' : case 'q' :
		System.exit(0);
		break;
	    }
	}
    }
}



