package Utilities.remClient;

import EventEvaluator.Resource.*;

import java.sql.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;

public class Client {
  
    private static org.omg.CORBA.ORB orb;

    private static ResourceManager bindResourceManager() {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    ResourceManager rm = null;
	    NameComponent [] name = new NameComponent[2];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("ResourceManager","service");
	    rm = 
		ResourceManagerHelper.narrow(nc.resolve(name));
	    return rm;
	}
	catch (Exception e) {
	    e.printStackTrace();
	    System.out.println("Could not bind to Resource Manager...");
	    System.exit(1);
	}
	return null;
    }

    private static ResourceEventRepository bindRERepository() {
	try {
	    // get reference to the initial naming context	    
	    NamingContextExt nc = 
		NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService")); 
	    ResourceEventRepository rer = null;
	    NameComponent [] name = new NameComponent[2];
	    name[0] = new NameComponent("Adaptacao","context");
	    name[1] = new NameComponent("ResourceEventRepository","service");
	    rer = 
		ResourceEventRepositoryHelper.narrow(nc.resolve(name));
	    return rer;
	}
	catch (Exception e) {
	    // e.printStackTrace();
	    System.out.println("Could not bind to Resource Event Repository...");
	    System.exit(1);
	}
	return null;
    }

    public static void main(String[] args) {
	String prompt = ">";

	// initialize 
	orb  = org.omg.CORBA.ORB.init(args, null);
	ResourceManager rm = bindResourceManager();
	ResourceEventRepository rer = bindRERepository();

	Utilities.Console cs = new Utilities.Console();

	while (true) {
	    System.out.println("--------------------------------");
	    System.out.println("b-begin e-end s-suspend r-resume q-quit");
	    System.out.println("--------------------------------");
	    char op = cs.readChar(prompt);
	    if ((op=='Q')||(op=='q')) {
		System.out.println("Bye...");
		System.exit(0);
	    }
	    String eid = cs.readString("enter eid: ");
	    try {
		switch (op) {
		case 'B' : case 'b' :
		    ResourceEvent re = rer.get_re_ref(eid);
		    rm.register(re);
		    break;	
		case 'E' : case 'e' :
		    rm.unregister(eid);
		    break;	
		case 'S' : case 's' :
		    rm.suspend(eid);
		    break;	
		case 'R' : case 'r' :
		    rm.resume(eid);
		    break;	
		}	
	    }
	    catch (EventEvaluator.NoSuchEvent nse) {
		System.out.println(nse.toString());
	    }
	    catch (EventEvaluator.EventNotBeeingEvaluated enbe) {
		System.out.println(enbe.toString());
	    }
	}
    }
}



