package Teste;

import java.io.*;
import java.util.*;

/** Classe GeraArq
 * Responsavel pela leitura e escrita nos arquivos invertidos e postings file
 */
public class Arq {

  private DataOutputStream arq; 

  /** Construtor
   * @param nome do arquivo
   */
  public Arq() {
    abre_arq("teste.txt");
  }

  /** Abre o arquivo txf
   * @param nome do arquivo
   */
  private void abre_arq(String nome) {
      
      try{
	  this.arq = new DataOutputStream (new FileOutputStream (nome, true));
      }
      catch (java.io.FileNotFoundException fnf) {
	  System.out.println(fnf.toString());
      }
  }   

  /** Realiza a escrita de uma String no arquivo arq
   * @param str string a ser inserida
   */
  public void escreve_str(String str) {
    try {
	arq.writeUTF(str);
    } catch ( EOFException eof ) { fecha_arq();
    } catch ( IOException e ) {
	System.err.println( "GeraArq.write_str(): " +
			    e.toString() );
	System.exit( 1 );
    }
  }

  /** Fecha o arquivo
   */
  public void fecha_arq() {
    try {
      arq.close();
    }
    catch ( IOException e ) {
      System.err.println( "Erro ao fechar arquivo\n" +
			  e.toString() );
      System.exit( 1 );
    }
  }
  
} // fim da classe GeraArq










