/*
 * readFile
 * Version 1.0
 */
package Teste;

import java.io.*;

/** 
 * Reads the file specified by the user.
 * This class encapsulates the methods necessary for reading a file.
 *
 * @author Francisco Silva
 * @version 1.0
 */
public class readFile {

    private BufferedReader input;
    private String file;

    /**
     * Receives the file name and open the file.
     * @param file the name of the file to be read
     */
    public readFile (String file) {
	this.file = file;
	open();
    }

    /**
     * Open the file.
     */    
    public void open() {  
	try {
	    input = new BufferedReader(new FileReader(file));
	    input.mark(25);
	}
	catch (IOException e) {
	    System.err.println("File" + file + "not opened properly\n" +
			       e.toString());
	    System.exit(1);
	}
    }

    /**
     * Close the file.
     */
    public void close() {
	try {
	    input.close();
	}
	catch (IOException e) {
	    System.err.println("Error closing file "+ file + "\n" +
			       e.toString());
	    System.exit(1);
	}
    }

    /**
     * Read one line of the file.
     * @return the line read
     */
    public String read1line() {
	String line = null;
	boolean end_of_file = false;
	try {
	    // input.reset();
	    line = input.readLine();
	}
	catch(IOException e) {
	    System.err.println("Error reading file" + file + "\n" +
			       e.toString());
	    System.exit(1);		
	}
	return line;
    }

} // end class reader
		



